## massxpert2 8.3.0

=== CMakeLists.txt ===
#############################################################
#############################################################
# CMake configuration
cmake_minimum_required(VERSION 3.18.4)

############################################################
############################################################
# Basic information about project

project(massXpert2
  DESCRIPTION "A program to model and simulate mass spectra on (bio-)polymers"
  HOMEPAGE_URL "http://wwww.msxpertsuite.org/massxpert")

set(LOWCASE_PROJECT_NAME massxpert2)

set(VERSION 8.3.0)


# Set additional project information
set(COMPANY "msXpertSuite.org")
set(COPYRIGHT "Copyright (c) 2008-2023 Filippo Rusconi. Licensed under GPLv3+")
set(IDENTIFIER "org.msxpertsuite")


include(GNUInstallDirs)

set(HOME_DEVEL_DIR $ENV{HOME}/devel)
message("\n${BoldRed}The devel directory where all the development projects
should reside: ${HOME_DEVEL_DIR}.${ColourReset}\n")


# Add folder where are supportive functions
set(CMAKE_UTILS_PATH ${CMAKE_SOURCE_DIR}/CMakeStuff)
set(CMAKE_TOOLCHAINS_PATH ${CMAKE_UTILS_PATH}/toolchains)
set(CMAKE_MODULE_PATH ${CMAKE_UTILS_PATH}/modules)

# This include must come before all the others
# It must include the config-generated config.h file
# before the others.
include_directories(${CMAKE_BINARY_DIR})

# And now the source directory contains the .h|.hpp files for its .cpp files.
include_directories(${CMAKE_SOURCE_DIR})

# For the config.h file.
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Include the system's uname that fills in SYSTEM_UNAME_S.
# Sets WIN32 if SYSTEM_UNAME_S is "^.*MING64.*"
# Note that WIN32 is set even on 64 bits systems.
include(${CMAKE_UTILS_PATH}/systemUname.cmake)

# Include the various colors we want to use in the output
include(${CMAKE_UTILS_PATH}/outputColors.cmake)

set(CMAKE_COLOR_MAKEFILE ON)
set(CMAKE_VERBOSE_MAKEFILE ON)

message("\n${BoldRed}Configuring build for project ${CMAKE_PROJECT_NAME}${ColourReset}\n")

# This export will allow using the flags to be used by
# youcompleteme (vim plugin).
set(CMAKE_EXPORT_COMPILE_COMMANDS 1)

if(EXISTS "${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json" )
  execute_process( COMMAND cmake -E copy_if_different
    ${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json
    ${CMAKE_SOURCE_DIR}/compile_commands.json
  )
endif()


# We want C++17
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
message(STATUS "${BoldGreen}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")

#############################################################
# We do not want warnings for unknown pragmas:
message(STATUS "Setting definition -Wno-unknown-pragmas.${ColourReset}")
add_definitions(-Wno-unknown-pragmas)

# Enable warnings and possibly treat them as errors
message(STATUS "${BoldGreen}Setting definition -Wall -pedantic.${ColourReset}")
add_definitions(-Wall -pedantic)
message(STATUS "${BoldGreen}Setting definition -Wextra.${ColourReset}")
add_definitions(-Wextra)

if(WARN_AS_ERROR)
  message(STATUS "${BoldYellow}Setting definition -Werror.${ColourReset}")
  add_definitions(-Werror)
endif()

message("${BoldGreen}CMAKE_SOURCE_DIR: ${CMAKE_SOURCE_DIR}${ColourReset}")


#############################################################
#############################################################
# Platform-specific CMake configuration
if(WIN32 OR _WIN32)

  if(MXE)

    # Run the following cmake command line:
    # x86_64-w64-mingw32.shared-cmake -DCMAKE_BUILD_TYPE=Release -DMXE=1 ../../development
    include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain.cmake)

    # Set the name to the systemUname variable because in this situation that name
    # is not found, it it passed as a flag in the command line.
    set(SYSTEM_UNAME_S "mxe")

  elseif(WIN10MINGW64)
    include(${CMAKE_TOOLCHAINS_PATH}/win10-mingw64-toolchain.cmake)
  endif()

elseif(UNIX)

  #message("UNIX")

  # On UNIX, the libpappsomspp and libpappsomspp-widget libs
  # need to be installed and they ship the PappsoMSppConfig.cmake
  # config file.

  # However, when developing both libs and this program, we need to be able to
  # load the libs from their dev/build directory without relying on the system
  # libs (add -DLOCAL_DEV=1).
  if(LOCAL_DEV)
    # The development should use the locally built libs.
    message("Using the local libpappsomspp libraries.")
    include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain-local.cmake)
  else()
    # The development should use the system-wide libs.
    include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain.cmake)

  endif()

  message(STATUS "Include dir for PappsoMSpp is at: ${PappsoMSpp_INCLUDE_DIRS}")
  message(STATUS "PappsoMSpp and PappsoMSppWidget were found:
  \t${PappsoMSpp_LIBRARIES} and ${PappsoMSppWidget_LIBRARIES}")

endif()

message("")
message(STATUS "${BoldGreen}Starting configuration of ${CMAKE_PROJECT_NAME}${ColourReset}")
message("")
message(STATUS "${BoldYellow}The build toolchain is: ${SYSTEM_UNAME_S}${ColourReset}")
message("")


#############################################################
#############################################################
# Essential software configuration
message(STATUS "CMAKE_CURRENT_BINARY_DIR: " ${CMAKE_CURRENT_BINARY_DIR})

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING
    "Type of build, options are: None, Debug, Release, RelWithDebInfo, MinSizeRel."
    FORCE)
endif(NOT CMAKE_BUILD_TYPE)

if(CMAKE_BUILD_TYPE MATCHES "Release")
  message(STATUS "Compiling in release mode.")
  add_definitions("-DQT_NO_DEBUG_OUTPUT")
endif()

if(CMAKE_BUILD_TYPE MATCHES "Debug")
  message(STATUS "Compiling in debug mode.")
  message(STATUS "Add definition -ggdb3 to format debug output for GDB.")
  add_definitions(-ggdb3)
endif()

if(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")
  message(STATUS "Compiling in release with debug info mode.")
endif( CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo" )

message(STATUS "${BoldYellow}CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}.${ColourReset}")


if(PROFILE)
  message(STATUS "${BoldYellow}Profiling is requested, adding -pg flag.${ColourReset}")
  add_definitions(-pg)
endif()

message(STATUS "${BoldYellow}Main CMAKE_BINARY_DIR: ${CMAKE_BINARY_DIR}${ColourReset}")
message(STATUS "${BoldYellow}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")

# It is essential to run these config steps before delving into the minexpert
# directory, because at that moment they will need what are
# going to prepare right now.
CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/CMakeStuff/splashscreen.svg.in
  ${CMAKE_SOURCE_DIR}/images/svg/splashscreen.svg @ONLY)

# Make the conversion of the svg file into a png, but only on GNU/Linux
if(UNIX)
  execute_process(COMMAND inkscape
    ${CMAKE_SOURCE_DIR}/images/svg/splashscreen.svg -o
    ${CMAKE_SOURCE_DIR}/images/splashscreen.png -w 600)
endif()

#############################################################
##################
# BUILD OF LIBMASS

message(STATUS "Adding subdirectory libmass for TARGET: ${TARGET}")
add_subdirectory(libmass)

#############################################################
#####################
# BUILD OF LIBMASSGUI

message(STATUS "Adding subdirectory libmassgui for TARGET: ${TARGET}")
add_subdirectory(libmassgui)

#############################################################
######################
# BUILD OF THE PROGRAM

message(STATUS "Adding subdirectory src for TARGET: ${TARGET}")
add_subdirectory(src)

#############################################################
###################
# BUILD OF THE DATA
message(STATUS "Adding subdirectory data for project: ${TARGET}")
add_subdirectory(data)

#############################################################
################################
# BUILD OF THE DOC / USER MANUAL
message(STATUS "Adding subdirectory doc for project: ${TARGET}")
add_subdirectory(doc)


# Use all the configured paths to create the config.h file.
# The config file is binary directory-specific !!!
CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/CMakeStuff/config.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/src/config.h @ONLY)


#############################################################
#############################################################
# Installation prefix
if (NOT CMAKE_INSTALL_PREFIX)
  SET (CMAKE_INSTALL_PREFIX /usr/local)
endif (NOT CMAKE_INSTALL_PREFIX)


####################################################
# Installation directories depending on the platform
####################################################

# See the CMakeStuff/toolchains platform-specific files.
message(STATUS "CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "BIN_DIR: ${BIN_DIR}")
message(STATUS "DATA_DIR: ${DATA_DIR}")
message(STATUS "DOC_DIR: ${DOC_DIR}")


#############################################################
###########################
# CREATE THE SOURCE PACKAGE
include(${CMAKE_UTILS_PATH}/targz-source-package-creation.cmake)

add_custom_target(archive
  cpack -G TGZ --config CPackSourceConfig.cmake && mv
  ${CMAKE_BINARY_DIR}/${LOWCASE_PROJECT_NAME}-${VERSION}.tar.gz
  ${CMAKE_SOURCE_DIR}/../tarballs && ln -sf
  ${CMAKE_SOURCE_DIR}/../tarballs/${LOWCASE_PROJECT_NAME}-${VERSION}.tar.gz
  ${CMAKE_SOURCE_DIR}/../${LOWCASE_PROJECT_NAME}_${VERSION}.orig.tar.gz && ln -sf
  ${CMAKE_SOURCE_DIR}/../tarballs/${LOWCASE_PROJECT_NAME}-${VERSION}.tar.gz
  ${CMAKE_SOURCE_DIR}/../tarballs/${LOWCASE_PROJECT_NAME}_${VERSION}.orig.tar.gz

  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
  COMMENT "Creating .tar.gz" VERBATIM
)


#############################################################
# summary
message("")
message(STATUS "${BoldRed}~~~~~~~~~~~~~~~~~~~~~~~~ SUMMARY ~~~~~~~~~~~~~~~~~~~~~~~~${ColourReset}")
message(STATUS "${BoldRed}   General configuration of the ${CMAKE_PROJECT_NAME} project ${ColourReset}")
message("")

message(STATUS "${BoldYellow}System is detected by CMake as ${SYSTEM_UNAME_S}${ColourReset}")
message(STATUS "${BoldYellow}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")
message(STATUS "${BoldYellow}CMAKE_CXX_STANDARD: ${CMAKE_CXX_STANDARD}${ColourReset}")

message("")

message(STATUS "${BoldYellow}CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}${ColourReset}")
message(STATUS "${BoldYellow}TARGET: ${TARGET}${ColourReset}")
message(STATUS "${BoldYellow}BIN_DIR: ${BIN_DIR}${ColourReset}")
message(STATUS "${BoldYellow}DOC_DIR: ${DOC_DIR}${ColourReset}")

if(PROFILE)
  message(STATUS "${BoldYellow}Profiling is requested (-DPROFILE=1)${ColourReset}")
else()
  message(STATUS "${BoldYellow}Profiling is NOT requested (-DPROFILE=0)${ColourReset}")
endif()

if(WARNASERR)
  message(STATUS "${BoldYellow}Warnings ARE treated as errors (-DWARNASERR=1)${ColourReset}")
else()
  message(STATUS "${BoldYellow}Warnings NOT treated as errors (-DWARNASERR=0)${ColourReset}")
endif()

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
  message(STATUS "${BoldYellow}Debug support IS requested.${ColourReset}")
else()
  message(STATUS "${BoldYellow}Debug support NOT requested.${ColourReset}")
endif()

message("")
message(STATUS "${BoldYellow}The typical cmake invocation on Debian GNU/Linux would be: cmake -DCMAKE_BUILD_TYPE=Debug -DBUILD_USER_MANUAL=1 ../../development${ColourReset}")
message(STATUS "${BoldYellow}The typical cmake invocation on win10-mingw64 would be: cmake -DCMAKE_BUILD_TYPE=Release  ../../development${ColourReset}") 
message(STATUS "${BoldYellow}The typical cmake invocation on MXE would be: x86_64-w64-mingw32.shared-cmake -DCMAKE_BUILD_TYPE=Release -DMXE=1 ../../development${ColourReset}") 
message("")

if(LOCAL_DEV)
  message("")
  message("${BoldGreen}USING LOCAL DEVELOPMENT CONFIG FOR PAPPSOMSPP")
  message("")
endif()

message("")
message(STATUS "${BoldRed}~~~~~~~~~~~~~~~~~~~~~~~~ SUMMARY ~~~~~~~~~~~~~~~~~~~~~~~~${ColourReset}")
message("")

=== doc/CMakeLists.txt ===
message("")
message(STATUS "${BoldGreen}Starting configuration for the doc material for ${CMAKE_PROJECT_NAME} ${ColourReset}")
message("")

# The UNIX man pages
if(UNIX AND NOT APPLE)

  message(STATUS "Going to generate the man pages.")

  execute_process(COMMAND docbook-to-man massxpert2.xml
    OUTPUT_FILE	${CMAKE_BINARY_DIR}/massxpert2.1
    WORKING_DIRECTORY	${CMAKE_CURRENT_SOURCE_DIR})

endif(UNIX AND NOT APPLE)


###############
# install stuff

# The history and licence files.

message("Installing the doc files in ${DOC_DIR}")
install(FILES history.html ../LICENSE 
  DESTINATION ${DOC_DIR})

# The man page.
if(UNIX AND NOT APPLE)
  install(FILES ${CMAKE_BINARY_DIR}/massxpert2.1
    DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man1)
endif()


#############################################################
###########################
# BUILD OF THE USER MANUALS

if(BUILD_USER_MANUAL)
  add_subdirectory(user-manual)
endif()


message("")
message(STATUS "${BoldGreen}Finished configuration of the doc material.${ColourReset}")
message("")

=== libmass/CMakeLists.txt ===
set(LIBNAME mass)

message(\n${BoldGreen}"Now configuring library ${LIBNAME}"${ColourReset}\n)

########################################################
# Files
set(${LIBNAME}_SRCS
  #
  # Most general features
  src/globals.cpp
  src/Prop.cpp
  src/PropListHolder.cpp
  #
  # The basic chemical features
  src/Isotope.cpp
  src/IsotopicData.cpp
  src/IsotopicDataBaseHandler.cpp
  src/IsotopicDataLibraryHandler.cpp
  src/IsotopicDataUserConfigHandler.cpp
  src/IsotopicDataManualConfigHandler.cpp
  src/IsotopicClusterGenerator.cpp
  src/IsotopicClusterShaper.cpp
  src/PeakCentroid.cpp
  src/Ponderable.cpp
  src/ChemicalGroup.cpp
  src/ChemicalGroupRule.cpp
  src/Modif.cpp
  src/ModifSpec.cpp
  src/Monomer.cpp
  src/MonomerDictionary.cpp
  src/MonomerSpec.cpp
  src/Oligomer.cpp
  src/Polymer.cpp
  src/CleaveMotif.cpp
  src/CleaveRule.cpp
  src/CleaveSpec.cpp
  src/Coordinates.cpp
  src/Formula.cpp
  src/FragRule.cpp
  src/FragSpec.cpp
  src/Ionizable.cpp
  src/IonizeRule.cpp
  src/CrossLink.cpp
  src/CrossLinker.cpp
  src/CrossLinkerSpec.cpp
  src/PolChemDef.cpp
  src/PolChemDefEntity.cpp
  src/PolChemDefSpec.cpp
  src/Sequence.cpp
  #
  # The calculation features
  src/CalcOptions.cpp
  src/MassPeakShaper.cpp
  src/MassPeakShaperConfig.cpp
  #
  # Envemind implementation
  src/Envemind.cpp
  #
  # The Averagine implementation
  src/Averagine.cpp
  #
  # The network functionality
  src/MassDataCborBaseHandler.cpp
  src/MassDataCborMassSpectrumHandler.cpp
  src/MassDataServer.cpp
  src/MassDataServerThread.cpp
  src/MassDataClient.cpp
)

# Because the header files are in their own directory and not along the source
# files, we need to have them listed explicitely for automoc to work properly
# below.
file(GLOB ${LIBNAME}_HEADERS ${CMAKE_CURRENT_LIST_DIR}/includes/lib${LIBNAME}/*.hpp)
message(STATUS "Included the header files from ${CMAKE_SOURCE_DIR}/includes/lib${LIBNAME}/")
message(STATUS "The header files: ${${LIBNAME}_HEADERS}")

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

###############################################################
# Configuration of the binary to be built
###############################################################

# Only now can we add the library, because we have defined the sources.

add_library(${LIBNAME} STATIC
  ${${LIBNAME}_HEADERS}
  ${${LIBNAME}_SRCS}
  ${PLATFORM_SPECIFIC_SOURCES}
)

include_directories(${CMAKE_CURRENT_LIST_DIR}/includes)
include_directories(${CMAKE_CURRENT_LIST_DIR}/includes/lib${LIBNAME})
include_directories(${CMAKE_CURRENT_BINARY_DIR})

target_include_directories(${LIBNAME} PUBLIC
  ${CMAKE_CURRENT_LIST_DIR}/includes
  ${CMAKE_CURRENT_LIST_DIR}/includes/lib${LIBNAME}
  ${CMAKE_CURRENT_BINARY_DIR})

#message(STATUS "CMAKE_CURRENT_BINARY_DIR: ${CMAKE_CURRENT_BINARY_DIR}")

set_target_properties(${LIBNAME}
  PROPERTIES OUTPUT_NAME mass
)

add_custom_command(TARGET ${LIBNAME}
  POST_BUILD
  COMMAND ${CMAKE_COMMAND} -E copy
  ${CMAKE_CURRENT_BINARY_DIR}/$<TARGET_FILE_NAME:${LIBNAME}>
  ${CMAKE_CURRENT_LIST_DIR}
)

# Finally actually set the linking dependencies to the executable.
target_link_libraries(${LIBNAME}
  Qt6::Xml
  Qt6::Network
  IsoSpec++::IsoSpec++
)

message("")
message(STATUS "${BoldGreen}Finished configuring of ${LIBNAME}.${ColourReset}")
message("")

=== libmass/Makefile ===
# This is a convenience file to use make from vim
# from wherever in the source code directories.
all: 
	cd ../../build-area/unix && make -j20

.PHONY: clean
clean:
	cd ../../build-area/unix && make clean

=== libmassgui/CMakeLists.txt ===
set(GUILIBNAME massgui)

message(\n${BoldGreen}"Now configuring library ${GUILIBNAME}"${ColourReset}\n)

########################################################
# Files
set(${GUILIBNAME}_SRCS
  src/IsotopicDataTableView.cpp
  src/ColorSelector.cpp
  src/IsotopicDataTableViewModel.cpp
  src/IsotopicClusterGeneratorDlg.cpp
  src/IsotopicClusterShaperDlg.cpp
  src/MassPeakShaperConfigDlg.cpp
  src/MassDataClientServerConfigDlg.cpp
  src/MassPeakShaperConfigWidget.cpp
)

set(${GUILIBNAME}_UIS
  src/ui/IsotopicClusterGeneratorDlg.ui
  src/ui/MassPeakShaperConfigDlg.ui
  src/ui/IsotopicClusterShaperDlg.ui
  src/ui/ElementGroupBoxWidget.ui
  src/ui/MassDataClientServerConfigDlg.ui
  src/ui/MassPeakShaperConfigWidget.ui
)

find_package(Qt6 COMPONENTS Widgets Core Gui PrintSupport Svg Xml Sql Concurrent REQUIRED)

qt6_wrap_ui(${GUILIBNAME}_UIS_H ${${GUILIBNAME}_UIS})

qt6_add_resources(${TARGET}_QRC_CPP libmassgui-ressources.qrc)

# Because the header files are in their own directory and not along the source
# files, we need to have them listed explicitely for automoc to work properly
# below.
file(GLOB ${GUILIBNAME}_HEADERS ${CMAKE_CURRENT_LIST_DIR}/includes/lib${GUILIBNAME}/*.hpp)
message(STATUS "Included the header files from ${CMAKE_SOURCE_DIR}/includes/lib${GUILIBNAME}/")
message(STATUS "The header files: ${${GUILIBNAME}_HEADERS}")

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

###############################################################
# Configuration of the binary to be built
###############################################################

# Only now can we add the library, because we have defined the sources.

add_library(${GUILIBNAME} STATIC
  ${${GUILIBNAME}_HEADERS}
  ${${GUILIBNAME}_SRCS}
  ${${GUILIBNAME}_UIS_H}
  ${${TARGET}_QRC_CPP}
  ${PLATFORM_SPECIFIC_SOURCES}
)

include_directories(${CMAKE_CURRENT_LIST_DIR}/includes)
include_directories(${CMAKE_CURRENT_LIST_DIR}/includes/lib${GUILIBNAME})
include_directories(${CMAKE_CURRENT_BINARY_DIR})

target_include_directories(${GUILIBNAME} PUBLIC
  ${CMAKE_CURRENT_LIST_DIR}/includes
  ${CMAKE_CURRENT_LIST_DIR}/includes/lib${GUILIBNAME}
  ${CMAKE_CURRENT_BINARY_DIR})

#message(STATUS "CMAKE_CURRENT_BINARY_DIR: ${CMAKE_CURRENT_BINARY_DIR}")

set_target_properties(${GUILIBNAME}
  PROPERTIES OUTPUT_NAME ${GUILIBNAME}
)

add_custom_command(TARGET ${GUILIBNAME}
  POST_BUILD
  COMMAND ${CMAKE_COMMAND} -E copy
  ${CMAKE_CURRENT_BINARY_DIR}/$<TARGET_FILE_NAME:${GUILIBNAME}>
  ${CMAKE_CURRENT_LIST_DIR}
)

# Finally actually set the linking dependencies to the library.
target_link_libraries(${GUILIBNAME}
  libmass::nongui
  Qt6::Widgets
  Qt6::Xml
  IsoSpec++::IsoSpec++
)

message("")
message(STATUS "${BoldGreen}Finished configuring of ${GUILIBNAME}.${ColourReset}")
message("")

=== src/CMakeLists.txt ===
message(\n${BoldRed}"Now configuring src/ for ${TARGET}"${ColourReset}\n)


########################################################
# Files
set(${TARGET}_nongui_SRCS
  nongui/globals.cpp
  nongui/CleaveOligomer.cpp
  nongui/CleaveOptions.cpp
  nongui/Cleaver.cpp
  nongui/CrossLinkedRegion.cpp
  nongui/FragOptions.cpp
  nongui/Fragmenter.cpp
  nongui/FragmentOligomer.cpp
  nongui/OligomerList.cpp
  nongui/OligomerPair.cpp
  nongui/PkaPhPi.cpp
  nongui/PkaPhPiDataParser.cpp
  nongui/PolChemDefCatParser.cpp
  nongui/MassList.cpp
  nongui/ConfigSetting.cpp
  nongui/ConfigSettings.cpp
  nongui/UserSpec.cpp
)


set(${TARGET}_gui_SRCS
  gui/AboutDlg.cpp
  gui/AbstractMainTaskWindow.cpp
  gui/AbstractPolChemDefDependentDlg.cpp
  gui/AbstractSeqEdWndDependentDlg.cpp
  gui/Application.cpp
  gui/ChemEntVignette.cpp
  gui/ChemEntVignetteRenderer.cpp
  gui/CalculatorChemPadDlg.cpp
  gui/CalculatorChemPadGroupBox.cpp
  gui/CalculatorRecorderDlg.cpp
  gui/CalculatorWnd.cpp
  gui/ChemPadButton.cpp
  gui/CleavageDlg.cpp
  gui/CleaveOligomerTableView.cpp
  gui/CleaveOligomerTableViewMimeData.cpp
  gui/CleaveOligomerTableViewModel.cpp
  gui/CleaveOligomerTableViewSortProxyModel.cpp
  gui/CleaveSpecDefDlg.cpp
  gui/CompositionTreeView.cpp
  gui/CompositionTreeViewItem.cpp
  gui/CompositionTreeViewModel.cpp
  gui/CompositionTreeViewSortProxyModel.cpp
  gui/CompositionsDlg.cpp
  gui/ConfigSettingsDlg.cpp
  gui/CrossLinkerDefDlg.cpp
  gui/DecimalPlacesOptionsDlg.cpp
  gui/FragSpecDefDlg.cpp
  gui/FragmentOligomerTableView.cpp
  gui/FragmentOligomerTableViewMimeData.cpp
  gui/FragmentOligomerTableViewModel.cpp
  gui/FragmentOligomerTableViewSortProxyModel.cpp
  gui/FragmentationDlg.cpp
  gui/IsotopeDefDlg.cpp
  gui/ProgramWindow.cpp
  gui/MassListSorterDlg.cpp
  gui/MassSearchDlg.cpp
  gui/MassSearchOligomerTableView.cpp
  gui/MassSearchOligomerTableViewMimeData.cpp
  gui/MassSearchOligomerTableViewModel.cpp
  gui/MassSearchOligomerTableViewSortProxyModel.cpp
  gui/ModifDefDlg.cpp
  gui/MonomerCodeEvaluator.cpp
  gui/MonomerCrossLinkDlg.cpp
  gui/MonomerDefDlg.cpp
  gui/MonomerModificationDlg.cpp
  gui/MzCalculationDlg.cpp
  gui/MzCalculationTreeView.cpp
  gui/MzCalculationTreeViewItem.cpp
  gui/MzCalculationTreeViewModel.cpp
  gui/MzCalculationTreeViewSortProxyModel.cpp
  gui/MzLabFormulaBasedActionsDlg.cpp
  gui/MzLabInputOligomerTableView.cpp
  gui/MzLabInputOligomerTableViewDlg.cpp
  gui/MzLabInputOligomerTableViewModel.cpp
  gui/MzLabInputOligomerTableViewSortProxyModel.cpp
  gui/MzLabMassBasedActionsDlg.cpp
  gui/MzLabMatchBasedActionsDlg.cpp
  gui/MzLabOutputOligomerTableView.cpp
  gui/MzLabOutputOligomerTableViewDlg.cpp
  gui/MzLabOutputOligomerTableViewModel.cpp
  gui/MzLabOutputOligomerTableViewSortProxyModel.cpp
  gui/MzLabWnd.cpp
  gui/PkaPhPiDlg.cpp
  gui/PolChemDefRendering.cpp
  gui/PolChemDefWnd.cpp
  gui/PolymerModificationDlg.cpp
  gui/RegionSelection.cpp
  gui/SeqToolsDlg.cpp
  gui/SequenceEditorFindDlg.cpp
  gui/SequenceEditorGraphicsView.cpp
  gui/SequenceEditorGraphicsViewKeySequenceHandling.cpp
  gui/SequenceEditorGraphicsViewKeyboardHandling.cpp
  gui/SequenceEditorWnd.cpp
  gui/SequenceImportDlg.cpp
  gui/SequencePurificationDlg.cpp
  gui/SequenceSelection.cpp
)

set(${TARGET}_UIS
  gui/ui/AboutDlg.ui
  gui/ui/AbstractPolChemDefDependentDlg.ui
  gui/ui/CalculatorChemPadDlg.ui
  gui/ui/CalculatorRecorderDlg.ui
  gui/ui/CalculatorWnd.ui
  gui/ui/CleavageDlg.ui
  gui/ui/CleaveSpecDefDlg.ui
  gui/ui/CompositionsDlg.ui
  gui/ui/ConfigSettingsDlg.ui
  gui/ui/CrossLinkerDefDlg.ui
  gui/ui/DecimalPlacesOptionsDlg.ui
  gui/ui/FragSpecDefDlg.ui
  gui/ui/FragmentationDlg.ui
  gui/ui/IsotopeDefDlg.ui
  gui/ui/MassSearchDlg.ui
  gui/ui/ModifDefDlg.ui
  gui/ui/MonomerCrossLinkDlg.ui
  gui/ui/MonomerDefDlg.ui
  gui/ui/MonomerModificationDlg.ui
  gui/ui/MzCalculationDlg.ui
  gui/ui/MzLabFormulaBasedActionsDlg.ui
  gui/ui/MzLabInputOligomerTableViewDlg.ui
  gui/ui/MzLabMassBasedActionsDlg.ui
  gui/ui/MzLabMatchBasedActionsDlg.ui
  gui/ui/MzLabOutputOligomerTableViewDlg.ui
  gui/ui/MzLabWnd.ui
  gui/ui/NumeralsLocaleConverterDlg.ui
  gui/ui/PkaPhPiDlg.ui
  gui/ui/PolChemDefWnd.ui
  gui/ui/PolymerModificationDlg.ui
  gui/ui/SequenceEditorFindDlg.ui
  gui/ui/SequenceEditorWnd.ui
  gui/ui/SequenceImportDlg.ui
  gui/ui/SequencePurificationDlg.ui
)

qt6_wrap_ui(${TARGET}_UIS_H ${${TARGET}_UIS})

qt6_add_resources(${TARGET}_QRC_CPP ../${LOWCASE_PROJECT_NAME}.qrc)

# Instruct CMake to run automatically when needed the following:
set(CMAKE_AUTOMOC ON) # For meta object compiler
set(CMAKE_AUTORCC ON) # Resource files

include_directories(

  # The config file is binary directory-specific !!!
  # For the config.h file generated from config.h.in
  # For the ui_Xyyyyy.h files
  ${CMAKE_CURRENT_BINARY_DIR}

  # For all the source subdirectories
  ${CMAKE_SOURCE_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}
)


###############################################################
# Configuration of the binary to be built
###############################################################

# Only now can we add the executable, because we have defined the sources of the
# object library above.

if(WIN32 OR _WIN32)

  add_executable(${TARGET}
    main.cpp
    ${${TARGET}_nongui_SRCS}
    ${${TARGET}_gui_SRCS}
    ${${TARGET}_UIS_H}
    ${${TARGET}_QRC_CPP}
    ${PLATFORM_SPECIFIC_SOURCES}
  )

  # In Debug mode we want the console to be opened so that we can read the debug
  # messages. But in Release mode the console is not desirable (the snippet
  # below removes it).
  if(CMAKE_BUILD_TYPE STREQUAL "Release")
    set_property(TARGET ${TARGET} PROPERTY WIN32_EXECUTABLE true)
  endif()

elseif(UNIX)

  add_executable(${TARGET}
    main.cpp
    ${${TARGET}_nongui_SRCS}
    ${${TARGET}_gui_SRCS}
    ${${TARGET}_UIS_H}
    ${${TARGET}_QRC_CPP}
    ${PLATFORM_SPECIFIC_SOURCES}
  )

endif()


# Finally actually set the linking dependencies to the executable.
# Note that there are so many cross-dependencies that it is virtually unfeasible
# to actually link the binary without resorting to the linker dance steps below.

# Still, I discovered that the order below is good with respect of the symbols
# dependencies resolutions when linking

# The general idea is to first list the libraries that *use* symbols and later
# libraries that *provide* symbols. Which is why all the Qt libs are listed at
# the end and the private libs are listed first.
target_link_libraries(${TARGET}

  -Wl,--whole-archive
  libmass::nongui
  libmass::gui
  -Wl,--no-whole-archive

  -Wl,--no-as-needed
  PappsoMSpp::Core
  -Wl,--as-needed

  -Wl,--no-as-needed
  IsoSpec++::IsoSpec++
  -Wl,--as-needed

  Qt6::Widgets
  Qt6::Svg
  Qt6::SvgWidgets
  Qt6::PrintSupport
  Qt6::Xml
  Qt6::Network
)


if(PROFILE)
  message(STATUS "Profiling is requested, adding linker -pg flag.")
  set (CMAKE_EXE_LINKER_FLAGS "-pg")
endif()

# We want to install the binary arch-dependent target in
# specific situations. To have proper control, we define the arch
# component.
install(TARGETS ${TARGET}
  RUNTIME
  COMPONENT arch
  DESTINATION ${BIN_DIR})


message("")
message(STATUS "${BoldGreen}Finished configuring of ${TARGET}.${ColourReset}")
message("")

=== doc/user-manual/CMakeLists.txt ===
if(BUILD_USER_MANUAL)
  
  if(UNIX)
    message("")
    message(STATUS "${BoldGreen}Starting configuration for the user manual for ${CMAKE_PROJECT_NAME} ${ColourReset}")
    message("")
    
    # Start by copying the whole user manual directory to the build directory
    file(COPY ${CMAKE_SOURCE_DIR}/doc/user-manual DESTINATION ${CMAKE_BINARY_DIR}/doc/)
    
    # The version of the program needs to be set in the user manual front
    # matter.
    CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/CMakeStuff/user-manual-version-entity.ent.in
    ${CMAKE_BINARY_DIR}/doc/user-manual/xml/user-manual-version-entity.ent @ONLY)
    
    # The location of the main user manual config file (set fop.xconf file
    # location)
    set(FOP_XCONF_DIR ${CMAKE_BINARY_DIR}/doc/user-manual)
    CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/CMakeStuff/DC-user-manual.cmake.in
    ${CMAKE_BINARY_DIR}/doc/user-manual/DC-user-manual @ONLY)
    
    # Command:
    # make usermanual
    # Makes use of the local  Makefile file.
    # Will generate HTML and PDF documentation in the build directory
    
    message("\tConfiguring the user manual compilation")
    
    add_custom_target(usermanual
    COMMAND make -f usermanual-makefile all_f
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/doc/user-manual
    COMMENT "Build of the DocBook-based user manual documentation")
    
    install(FILES
      ${CMAKE_BINARY_DIR}/doc/user-manual/build/user-manual/${TARGET}-doc.pdf
      DESTINATION ${DOC_DIR})
      
      install(DIRECTORY 
        ${CMAKE_BINARY_DIR}/doc/user-manual/build/user-manual/html/user-manual/
        DESTINATION ${DOC_DIR}/html)
        
        message("")
        message(STATUS "${BoldGreen}Finished configuring the ${CMAKE_PROJECT_NAME} user manual.${ColourReset}")
        message("")
        
  else()
    
    message(STATUS "User manual build skipped")
    
  endif()
  
endif()

=== debian/changelog ===
massxpert2 (8.3.0-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 17:56:10 +1100

massxpert2 (8.3.0-1build1) noble; urgency=medium

  * No-change rebuild against libqt6core6t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 12 Mar 2024 01:54:24 +0000

massxpert2 (8.3.0-1) unstable; urgency=low

  * New upstream version:
    * New polymer chemistry definition with 98% labelled C13 and N15.
    * Fix crash with QTimer triggering single shot after its destruction.
    * Code cleanup and fix to memory leak in client-server code.
    * Compile the user manual in the binary source tree

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 21 Nov 2023 16:23:48 +0100

massxpert2 (8.2.0-1) unstable; urgency=low

  * New upstream package.

  * Two metapackages ensure that an upgrade of massxpert (or massxpert-doc)
    pulls in the new packages.

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 23 Jun 2023 16:37:54 +0200

massxpert2 (8.1.0-1) unstable; urgency=low

  * New upstream version featuring the dynamic loading of isotopic data from
    disk files in the sequence editor, the cleavage dialog window and the
    fragmentation dialog window.

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 20 Jun 2023 17:23:30 +0200

massxpert2 (8.0.1-1) unstable; urgency=low

  * New upstream version fixing bug with synthetic mass spectrum
    normalization.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 27 Apr 2023 13:34:52 +0200

massxpert2 (8.0.0-1) unstable; urgency=low

  * Rename the software massXpert -> massXpert2.

  * Refactoring all the framework describing the chemical entities: abandoned
    the Atom/AtomCount paradigm in favor of a complete list of isotopes
    (IsotopicData). This works aims at streamlining all the future features
    related to isotopic cluster modelling.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 16 Feb 2023 13:07:18 +0100

massxpert (7.1.0-1) unstable; urgency=low

  * New version implementing a new project hierarchy: libmass and libmassgui
    private static libraries enshrine all the functionalities that might be
    used in other project. The implementation is based on git submodules.

  * Added the possibility to perform isotopic cluster calculations and mass
    peak shape calculations.

  * Added build dependencies for the new features.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 05 Jan 2023 18:57:10 +0100

massxpert (7.0.0-2) unstable; urgency=low

  * d/control: update version of daps dependency package to 3.3.2;
  * d/control: remove useless build dependencies;
  * debian/source/lintian-overrides: reinstate.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 19 Dec 2022 17:35:50 +0100

massxpert (7.0.0-1) unstable; urgency=low

  * Major release with all the code ported to Qt6. This release is a Qt6-based
    build.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 31 Oct 2022 21:31:52 +0100

massxpert (6.1.0-1) unstable; urgency=low

  * Reworked all the user manual to make it more modern DocBook5 code. Thanks
    to the OpenSUSE crew for advice, in particular Tom Schraitle.

  * Upload after removal due to daps not building.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 17 Oct 2022 10:29:43 +0200

massxpert (6.0.3-1) unstable; urgency=low

  * Removed the MathML dependency that was too problematic (see #994795).
    Replace formulas in <mml> elements with figures. Adapted the text of the
    user manual.

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 02 Feb 2022 11:52:16 +0100

massxpert (6.0.2-1) unstable; urgency=low

  * Fixes with the user manual build and versioning.

  * Update the user manual itself.

  * texlive-fonts-extra (>= 2020.20210202) (add version).

  * Fix filenames of the STIX2 fonts used for the user manual. The bug was
    reported by Lucas Nussbaum <lucas@debian.org>. Thanks to Juhani Numminen
    <juhaninumminen0@gmail.com> and Dennis Filder <d.filder@web.de> for
    suggesting fixes (Closes: #982725).

  * Standards-Version: 4.5.1. No changes required.

 -- Filippo Rusconi <lopippo@debian.org>  Sat, 20 Feb 2021 19:14:56 +0100

massxpert (6.0.1-1) unstable; urgency=low

  * Implement ready access to the user manual from the help/about dialog
    window.

  * Some improvements in the CMake-based build system.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 23 Jul 2020 18:58:02 +0200

massxpert (6.0.0-1) unstable; urgency=low

  * New packaging that is now independent of msXpertSuite and that will be
    shipped separately from the mineXpert2 package. This software is
    considered featureful and stable. It won't change as much as minexpert2,
    so shipping it separately now makes sense.

  * Note that a number of deprecation warnings were fixed due to the
    upgrade to Qt 5.14 from 5.12 (qSort() -> std::sort() and 
    qGreater<Type>() -> std::greater<Type>() and 
    QMatrix -> QTransform).

  * The version number starts at 6.0.0.

  * I have conserved the package history below just for the record.

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 01 Jul 2020 17:35:32 +0200

msxpertsuite (5.8.7-1) UNRELEASED; urgency=low

  * Fixes to the icons handling.

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 13 Mar 2019 14:47:15 +0100

msxpertsuite (5.8.6-2) unstable; urgency=low

  * d/control: +Homepage: http://www.msxpertsuite.org/ (not https).

  * Fix the license mismatch output by lintian (appstream.xml file vs
    d/copyright).

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 06 Mar 2019 12:40:54 +0100

msxpertsuite (5.8.6-1) unstable; urgency=low

  * Reinstate partially all the conflicts/breaks/replaces statements for the
    mspxertsuite-massxpert binary package. This ensures that upgrade of
    massxpert from stable's version to this version does not stumble upon
    overwriting blocks. Thanks to Andreas Beckmann
    <anbe@debian.org> for reporting the piuparts log (Closes: #922287).

  * Took advantage to update the


=== debian/control ===
Source: massxpert2
Section: science
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
Uploaders: Filippo Rusconi <lopippo@debian.org>
Build-Depends: debhelper-compat (= 13),
 dpkg-dev (>= 1.21.22),
# To export from svg to png
 inkscape,
 qt6-base-dev,
 libqt6svg6-dev,
 cmake (>= 3.12),
 libisospec++-dev (>=2.2.1),
 libpappsomspp-dev (>= 0.9.12),
 daps (>= 3.3.2),
 docbook-xml,
 libjs-jquery,
 libjs-highlight.js,
 texlive-fonts-extra (>= 2020.20210202),
 fonts-ebgaramond-extra,
 fonts-urw-base35,
 imagemagick-6-common,
 docbook-to-man
Standards-Version: 4.6.1
Homepage: http://www.msxpertsuite.org/
Vcs-Browser: https://salsa.debian.org/debichem-team/massxpert2
Vcs-Git: https://salsa.debian.org/debichem-team/massxpert2.git


Package: massxpert
Depends: massxpert2,
         ${misc:Depends},
Architecture: all
Priority: optional
Section: oldlibs
Description: transitional package for massxpert -> massxpert2
 This is a transitional package. It can safely be removed.
 Runtime package.


Package: massxpert-doc
Depends: massxpert2-doc,
         ${misc:Depends},
Architecture: all
Priority: optional
Section: oldlibs
Description: transitional package for massxpert-doc -> massxpert2-doc
 This is a transitional package. It can safely be removed.
 Documentation package.

Package: massxpert2
Architecture: any
Depends: ${shlibs:Depends},
				 ${misc:Depends},
         massxpert2-data (>= ${source:Upstream-Version})
Suggests: massxpert2-doc (>= ${source:Upstream-Version})
Replaces: massxpert (<< 8.1.0-1~)
Breaks: massxpert (<< 8.1.0-1~)
Description: polymer chemistry modelling and mass spectrometry data simulation (runtime)
 massXpert2 allows the user to perform the following tasks:
 .
  - Make brand new polymer chemistry definitions;
  - Use the definitions to easily perform calculations in a desktop
    calculator-like manner;
  - Perform sophisticated polymer sequence editing and simulations;
  - Perform m/z list comparisons;
  - Perform isotopic cluster simulations.
 .
 Chemical simulations encompass cleavage (either chemical or
 enzymatic), gas-phase fragmentations, chemical modification of any
 monomer in the polymer sequence, cross-linking of monomers in the
 sequence, arbitrary mass searches...
 .
 This package ships the massXpert2 program.


Package: massxpert2-data
Architecture: all
Depends: ${misc:Depends},
Suggests: massxpert2-doc (>= ${source:Upstream-Version})
Replaces: massxpert-data (<< 8.1.0-1~)
Breaks: massxpert-data (<< 8.1.0-1~)
Description: polymer chemistry modelling and mass spectrometry data simulation (data)
 massXpert2 allows the user to perform the following tasks:
 .
  - Make brand new polymer chemistry definitions;
  - Use the definitions to easily perform calculations in a desktop
    calculator-like manner;
  - Perform sophisticated polymer sequence editing and simulations;
  - Perform m/z list comparisons;
  - Perform isotopic cluster simulations.
 .
 Chemical simulations encompass cleavage (either chemical or
 enzymatic), gas-phase fragmentations, chemical modification of any
 monomer in the polymer sequence, cross-linking of monomers in the
 sequence, arbitrary mass searches...
 .
 This package ships the polymer chemistry data.


Package: massxpert2-doc
Section: doc
Architecture: all
Depends: libjs-jquery,
         libjs-highlight.js,
         ${misc:Depends}
Replaces: massxpert-doc (<< 8.1.0-1~)
Breaks: massxpert-doc (<< 8.1.0-1~)
Description: polymer chemistry modelling and mass spectrometry data simulation (doc)
 massXpert2 allows the user to perform the following tasks:
 .
  - Make brand new polymer chemistry definitions;
  - Use the definitions to easily perform calculations in a desktop
    calculator-like manner;
  - Perform sophisticated polymer sequence editing and simulations;
  - Perform m/z list comparisons;
  - Perform isotopic cluster simulations.
 .
 Chemical simulations encompass cleavage (either chemical or
 enzymatic), gas-phase fragmentations, chemical modification of any
 monomer in the polymer sequence, cross-linking of monomers in the
 sequence, arbitrary mass searches...
 .
 This package ships the user manual in both PDF and HTML formats.

=== debian/rules ===
#!/usr/bin/make -f
# Based on the initial work of Joey Hess and Craig Small.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# Set path to this directory so that our tweaked fop script is used.
PATH := $(CURDIR)/doc/user-manual/scripts:$(PATH)
$(info PATH: $(PATH))

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk


%:
	dh $@

# Required to stop it from calling my convenience Makefile that is only used for
# my day-to-day work.
override_dh_auto_clean:

override_dh_clean:
	dh_clean
	rm -rf debian/build
	rm -rf debian/tmp
	rm -f libmass/libmass.a
	rm -f libmassgui/libmassgui.a
	rm -f compile_commands.json
	
override_dh_auto_configure:
	mkdir -p debian/build
	mkdir -p debian/tmp
	cd debian/build && cmake -DCMAKE_BUILD_TYPE=Release -DBUILD_USER_MANUAL=1 -DCMAKE_INSTALL_PREFIX=/usr ../..

	# Ensure that the fop.xconf file is found in the DC* files
	# that are located in $(CURDIR)/doc/user-manual

	cd debian/build/doc/user-manual && \
		sed -i 's|/home/rusconi/devel/minexpert2/development/doc/user-manual/fop.xconf|debian/build/doc/user-manual/fop.xconf|' DC-user-manual

override_dh_auto_build:
	cd debian/build && make
	cd debian/build && make usermanual

override_dh_compress:
	dh_compress -X.pdf

override_dh_auto_install:
	cd debian/build && DESTDIR=../tmp make install
	dh_install

## massxpert2 8.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,17 +8,16 @@
 # Basic information about project
 
 project(massXpert2
-  DESCRIPTION "A program to model and simulate mass spectra on (bio-)polymers"
-  HOMEPAGE_URL "http://wwww.msxpertsuite.org/massxpert")
+  DESCRIPTION "A program to model and simulate mass spectra on linear (bio-)polymers"
+  HOMEPAGE_URL "http://wwww.msxpertsuite.org/massxpert2")
 
 set(LOWCASE_PROJECT_NAME massxpert2)
 
-set(VERSION 8.3.0)
-
+set(VERSION 8.4.0)
 
 # Set additional project information
 set(COMPANY "msXpertSuite.org")
-set(COPYRIGHT "Copyright (c) 2008-2023 Filippo Rusconi. Licensed under GPLv3+")
+set(COPYRIGHT "Copyright (c) 2008-2024 Filippo Rusconi. Licensed under GPLv3+")
 set(IDENTIFIER "org.msxpertsuite")
 
 
@@ -77,7 +76,7 @@
 
 #############################################################
 # We do not want warnings for unknown pragmas:
-message(STATUS "Setting definition -Wno-unknown-pragmas.${ColourReset}")
+message(STATUS "${BoldGreen}Setting definition -Wno-unknown-pragmas.${ColourReset}")
 add_definitions(-Wno-unknown-pragmas)
 
 # Enable warnings and possibly treat them as errors
@@ -87,7 +86,7 @@
 add_definitions(-Wextra)
 
 if(WARN_AS_ERROR)
-  message(STATUS "${BoldYellow}Setting definition -Werror.${ColourReset}")
+  message(STATUS "${BoldGreen}Setting definition -Werror.${ColourReset}")
   add_definitions(-Werror)
 endif()
 
@@ -184,7 +183,7 @@
 message(STATUS "${BoldYellow}Main CMAKE_BINARY_DIR: ${CMAKE_BINARY_DIR}${ColourReset}")
 message(STATUS "${BoldYellow}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")
 
-# It is essential to run these config steps before delving into the minexpert
+# It is essential to run these config steps before delving into the massxpert
 # directory, because at that moment they will need what are
 # going to prepare right now.
 CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/CMakeStuff/splashscreen.svg.in
@@ -201,15 +200,15 @@
 ##################
 # BUILD OF LIBMASS
 
-message(STATUS "Adding subdirectory libmass for TARGET: ${TARGET}")
-add_subdirectory(libmass)
+message(STATUS "Adding subdirectory libmass/src for TARGET: ${TARGET}")
+add_subdirectory(libmass/src)
 
 #############################################################
 #####################
 # BUILD OF LIBMASSGUI
 
-message(STATUS "Adding subdirectory libmassgui for TARGET: ${TARGET}")
-add_subdirectory(libmassgui)
+message(STATUS "Adding subdirectory libmassgui/src for TARGET: ${TARGET}")
+add_subdirectory(libmassgui/src)
 
 #############################################################
 ######################
@@ -230,6 +229,14 @@
 message(STATUS "Adding subdirectory doc for project: ${TARGET}")
 add_subdirectory(doc)
 
+
+#############################################################
+####################
+# BUILD OF THE TESTS
+if(BUILD_TESTS)
+message(STATUS "Adding subdirectory tests for building tests for project: ${TARGET}")
+add_subdirectory(tests)
+endif()
 
 # Use all the configured paths to create the config.h file.
 # The config file is binary directory-specific !!!
@@ -313,8 +320,8 @@
 
 message("")
 message(STATUS "${BoldYellow}The typical cmake invocation on Debian GNU/Linux would be: cmake -DCMAKE_BUILD_TYPE=Debug -DBUILD_USER_MANUAL=1 ../../development${ColourReset}")
-message(STATUS "${BoldYellow}The typical cmake invocation on win10-mingw64 would be: cmake -DCMAKE_BUILD_TYPE=Release  ../../development${ColourReset}") 
-message(STATUS "${BoldYellow}The typical cmake invocation on MXE would be: x86_64-w64-mingw32.shared-cmake -DCMAKE_BUILD_TYPE=Release -DMXE=1 ../../development${ColourReset}") 
+message(STATUS "${BoldYellow}The typical cmake invocation on win10-mingw64 would be: cmake -DCMAKE_BUILD_TYPE=Release  ../../development${ColourReset}")
+message(STATUS "${BoldYellow}The typical cmake invocation on MXE would be: x86_64-w64-mingw32.shared-cmake -DCMAKE_BUILD_TYPE=Release -DMXE=1 ../../development${ColourReset}")
 message("")
 
 if(LOCAL_DEV)

=== debian/changelog ===
massxpert2 (8.4.0-1) unstable; urgency=low

  * Add new polymer chemistry definition for fully labelled N;
  * Improve the ChemicalPad config for some sugars;
  * Implemented basic functionality in Averagine;
  * Allow using a double as a count for the formula;
  * Implemented the formula checkSyntax function using a RegularExpression;
  * Reconfigure the source tree to accomodate libmass and libmassgui
    as true git submodules;
  * MXE-based build works flawlessly;
  * Network-based communications between mineXpert2 and massXpert2
    now work perfectly;
  * Updated the user manual.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 02 May 2024 14:11:55 +0200

massxpert2 (8.3.1-1) unstable; urgency=low

  * Rework the user manual build system.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 07 Dec 2023 12:17:36 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: massxpert2
 Section: science
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
+Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
 Uploaders: Filippo Rusconi <lopippo@debian.org>
 Build-Depends: debhelper-compat (= 13),
  dpkg-dev (>= 1.21.22),
@@ -10,9 +9,10 @@
  inkscape,
  qt6-base-dev,
  libqt6svg6-dev,
+ libxkbcommon-x11-dev,
  cmake (>= 3.12),
  libisospec++-dev (>=2.2.1),
- libpappsomspp-dev (>= 0.9.12),
+ libpappsomspp-dev (>= 0.9.31),
  daps (>= 3.3.2),
  docbook-xml,
  libjs-jquery,
@@ -22,7 +22,7 @@
  fonts-urw-base35,
  imagemagick-6-common,
  docbook-to-man
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: http://www.msxpertsuite.org/
 Vcs-Browser: https://salsa.debian.org/debichem-team/massxpert2
 Vcs-Git: https://salsa.debian.org/debichem-team/massxpert2.git
@@ -32,7 +32,6 @@
 Depends: massxpert2,
          ${misc:Depends},
 Architecture: all
-Priority: optional
 Section: oldlibs
 Description: transitional package for massxpert -> massxpert2
  This is a transitional package. It can safely be removed.
@@ -43,7 +42,6 @@
 Depends: massxpert2-doc,
          ${misc:Depends},
 Architecture: all
-Priority: optional
 Section: oldlibs
 Description: transitional package for massxpert-doc -> massxpert2-doc
  This is a transitional package. It can safely be removed.
